=begin
TIG (c) 2015-2016
All rights reserved.
TIG-LayerWatcher_code...
 LanguageHandler added by M.Chabot
=end
###
module TIG
 module LayerWatcher
	### tidy up obsolete files etc
	data_folder = File.join(FOLDER, "Data")
	data=File.join(data_folder, "Data.txt")
	if File.exist?(data)
		begin
			File.delete(data)
		rescue
		end
	end
	main=File.join(data_folder, "TIG-LayerWatcher_main_code.rb")
	if File.exist?(main)
		begin
			File.delete(main)
		rescue
		end
	end
	if File.exist?(data_folder)
		begin
			Dir.delete(data_folder)
		rescue
		end
	end
	###
	###
	unless file_loaded?(__FILE__)
		UI.add_context_menu_handler{|menu|
			menu.add_item((LwLH["Selected-Geometry-To-Layer0"])){ self.to_layer0() } if self.geometry?()
			menu.add_item((LwLH["Explode-To-Layer0"])){ self.explode_to_layer0() } if self.containers?()
		}
		file_loaded(__FILE__)
	end
	###
	###
	def self.geometry?()
		@ss = Sketchup.active_model.selection
		geom = @ss.grep(Sketchup::Edge) + @ss.grep(Sketchup::Face)
		geom.flatten!
		@geometry = geom.select{|e| e.layer.name != "Layer0" }
		@nested_geometry = []
		@processed_defns = []
		self.nested_geometry?(@ss.grep(Sketchup::Group) + @ss.grep(Sketchup::ComponentInstance))
		@nested_geometry.flatten!
		@nested_geometry.compact!
		@nested_geometry.uniq!
		if @geometry[0] || @nested_geometry[0]
			return true
		else
			return false
		end
	end
	###
	def self.containers?()
		@ss = Sketchup.active_model.selection
		conts = @ss.grep(Sketchup::Group) + @ss.grep(Sketchup::ComponentInstance)
		conts.flatten!
		conts.compact!
=begin
		geom = []
		conts.each{|e|
			if e.is_a?(Sketchup::Group)
				ents = e.entities
			else
				ents = e.definition.entities
			end
			gs = ents.grep(Sketchup::Edge)
			geom << gs if gs[0]
			break if geom[0]
		}
		if geom[0]
=end
		if conts[0]
			return true
		else
			return false
		end
	end
	###
	def self.nested_geometry?(ents=[])
		return unless ents[0]
		###
		geometry = []
		geom = ents.grep(Sketchup::Edge)
		geom << ents.grep(Sketchup::Face)
		geom.flatten!
		geometry << geom.select{|e| e.layer.name != "Layer0" }
		geometry.flatten!
		geometry.compact!
		###
		gps = ents.grep(Sketchup::Group)
		gps.each{|gp|
			next if @processed_defns.include?(gp.entities.parent)
			@processed_defns << gp.entities.parent
			geom = gp.entities.grep(Sketchup::Edge)
			geom << gp.entities.grep(Sketchup::Face)
			geom.flatten!
			geom.compact!
			geometry << geom.select{|e| e.layer.name != "Layer0" }
			geometry.flatten!
			geometry.compact!
			ngps = gp.entities.grep(Sketchup::Group)
			ngps.each{|e| self.nested_geometry?(e.entities.to_a) }
			nins = gp.entities.grep(Sketchup::ComponentInstance)
			nins.each{|e| self.nested_geometry?(e.definition.entities.to_a) }
		}
		ins = ents.grep(Sketchup::ComponentInstance)
		ins.each{|i|
			next if @processed_defns.include?(i.definition)
			@processed_defns << i.definition
			geom = i.definition.entities.grep(Sketchup::Edge)
			geom << i.definition.entities.grep(Sketchup::Face)
			geom.flatten!
			geom.compact!
			geometry << geom.select{|e| e.layer.name != "Layer0" }
			geometry.flatten!
			geometry.compact!
			ngps = i.definition.entities.grep(Sketchup::Group)
			ngps.each{|e| self.nested_geometry?(e.entities.to_a) }
			nins = i.definition.entities.grep(Sketchup::ComponentInstance)
			nins.each{|e| self.nested_geometry?(e.definition.entities.to_a) }
		}
		###
		@nested_geometry << geometry if geometry[0]
		###
	end
	###
	def self.to_layer0()
		if @nested_geometry[0]
			UI.beep
			yn = UI.messagebox((LwLH["Assign Layer0 to All Nested Geometry in the Selection ?"]), MB_YESNO)
			if yn == 6
				@geometry = @geometry + @nested_geometry
				@geometry.flatten!
				@geometry.compact!
				@geometry.uniq!
			end
		else
			yn = -1
		end
		model = Sketchup.active_model
		layers = model.layers
		model.start_operation("Selected-Geometry-To-Layer0", true)
		  @geometry.each{|e| e.layer = layers[0] }
		model.commit_operation
		if @geometry[0]
			es = @geometry.grep(Sketchup::Edge).length
			ess="s"
			ess="" if es<=1
			fs = @geometry.grep(Sketchup::Face).length
			fss="s"
			fss="" if fs<=1
			sA = [es,ess,fs,fss]
			msg = (LwLH["Reassigned Layer0 to %s Edge%s and %s Face%s."]) % sA
			if @nested_geometry[0]
				es = @nested_geometry.grep(Sketchup::Edge).length
				ess="s"
				ess="" if es<=1
				fs = @nested_geometry.grep(Sketchup::Face).length
				fss="s"
				fss="" if fs<=1
				ds = @processed_defns.length
				dss="s"
				dss="" if ds<=1
				sA = [es,ess,fs,fss,ds,dss]
				if yn == 6
					msg << "\n" + (LwLH["Including %s Edge%s and %s Face%s found nested within %s Selected Object%s."]) % sA
				else
					msg << "\n" + (LwLH["Skipped %s Edge%s and %s Face%s found nested within %s Selected Object%s."]) % sA
				end
			end
			UI.messagebox(msg)
		end
	end
	###
	def self.explode_to_layer0()
		@model = Sketchup.active_model
		layer0 = @model.layers[0]
		ss = @model.selection
		conts = ss.grep(Sketchup::Group) + ss.grep(Sketchup::ComponentInstance)
		conts.flatten!
		@model.start_operation("Explode-To-Layer0", true)
			enum = 0
			fnum = 0
			enum0 = 0
			fnum0 = 0
			conts.each{|e|
				if e.layer.name == "Layer0"
					elay0=true
				else
					elay0=false
				end
				ents = e.explode
				geom = ents.grep(Sketchup::Edge) + ents.grep(Sketchup::Face)
				geom.flatten!
				geom.each{|g|
					if g.layer == layer0 && elay0
						enum0 += 1 if g.is_a?(Sketchup::Edge)
						fnum0 += 1 if g.is_a?(Sketchup::Face)
						next
					end
					g.layer = layer0
					enum += 1 if g.is_a?(Sketchup::Edge)
					fnum += 1 if g.is_a?(Sketchup::Face)
				}
			}
		@model.commit_operation
		ess="s"
		ess="" if enum <= 1
		fss="s"
		fss="" if fnum <= 1
		ess0="s"
		ess0="" if enum0 <= 1
		fss0="s"
		fss0="" if fnum0 <= 1
		sA = [enum,ess,fnum,fss]
		sB = [enum0,ess0,fnum0,fss0]
		if enum > 0 || fnum > 0
			msg = (LwLH["Exploded, then Reassigned Layer0 to %s Edge%s and %s Face%s."]) % sA
			if enum0 > 0 || fnum0 > 0
				msg << "\n" + (LwLH[" and Layer0 already Assigned to %s Edge%s and %s Face%s."]) % sB
			end
		else
			if enum0 > 0 || fnum0 > 0
				msg = (LwLH["Exploded,  but Layer0 already Assigned to %s Edge%s and %s Face%s."]) %sB
			else
				msg = (LwLH["No Geometry to process in Exploded Entities !"])
			end
		end
		UI.messagebox(msg)
	end
	###
	### Observers ###
	class LayersObserver < Sketchup::LayersObserver
		def onCurrentLayerChanged(layers, layer)
			begin
				model = layer.model
			rescue
				return
			end
			return if model.tools.active_tool_name == "RubyTool" ### if inside Plugin skip
			return if layer.name == "Camera_FOV_Lines" || layer.name == "Camera_FOV_Volume" ### ACT trap
			unless layer.name == "Layer0"
			
				UI.beep
				if UI.messagebox((LwLH["You should normally model with the current-layer set as Layer0 !"]) + "\n" +
								(LwLH["Do you really want to change it to"]) + "\n" +
								"#{layer.name} ?", MB_YESNO) == 7
					UI.start_timer(0.1, false){
						model.start_operation("Layer0", true, false, true)
							model.active_layer = layers[0]
						model.commit_operation
					}
				end
			end
		end
  end
	###
	LO = LayersObserver.new()
  @model = Sketchup.active_model
	@layers = @model.layers
	begin
		@layers.remove_observer(LO)
		@layers.add_observer(LO)
	rescue
		raise
	end
	###
	class EntitiesObserver < Sketchup::EntitiesObserver
		include LayerWatcher
		def onElementAdded(entities, entity)
			return unless entity.valid?
			if entity.is_a?(Sketchup::Group) || entity.is_a?(Sketchup::ComponentInstance)
				self.attach_EO(entity)
				return
			end
			model = entity.model
			layer0 = model.layers[0]
			#p model.tools.active_tool_name
			return if model.tools.active_tool_name == "RubyTool" ### if inside Plugin skip
			return if model.tools.active_tool_name == "SelectionTool" ### e.g. Exploded geometry
			return if entity.layer == layer0
			return unless entity.is_a?(Sketchup::Edge) || entity.is_a?(Sketchup::Face)
			if RUBY_PLATFORM.downcase =~ /darwin/ ### MAC
				UI.start_timer(0, false){
					model.start_operation("Layer0", true, false, true)
						begin
							entity.layer = layer0
						rescue
							model.commit_operation
							raise
						end
					model.commit_operation
				}
			else ### PC
				model.start_operation("Layer0", true, false, true)
					begin
						entity.layer = layer0
					rescue
						model.commit_operation
						raise
					end
				model.commit_operation
			end
		end
		###
		def attach_EO(entity)
			return unless entity.valid?
			if entity.is_a?(Sketchup::ComponentInstance)
				definition = entity.definition
			else ### group
				definition = entity.entities.parent
			end
			return unless definition.valid?
			begin
				definition.entities.remove_observer(EO)
				definition.entities.add_observer(EO)
			rescue
				raise
			end
		end
	end
	###
	EO = EntitiesObserver.new()
	@model = Sketchup.active_model
	@ents = @model.entities
	begin
		@ents.remove_observer(EO)
		@ents.add_observer(EO)
	rescue
		raise
	end
	###
	@model = Sketchup.active_model
	@definitions = @model.definitions
	### process existing entities
	@definitions.each{|definition|
		next if ! definition.valid? || definition.image?
		begin
			definition.entities.remove_observer(EO)
			definition.entities.add_observer(EO)
		rescue
			raise
		end
	}
	### trap for definitions made from groups etc...
	class DefinitionsObserver < Sketchup::DefinitionsObserver
		include LayerWatcher
		def onComponentTypeChanged(definitions, definition)
			return unless definition.valid?
			unless definition.image?
				begin
					definition.entities.remove_observer(EO)
					definition.entities.add_observer(EO)
				rescue
					raise
				end
			end
		end
	end
	### add initially
	DO = DefinitionsObserver.new()
	begin
		@definitions.remove_observer(DO)
		@definitions.add_observer(DO)
	rescue
		raise
	end
	###
	class AppObserver < Sketchup::AppObserver
		include LayerWatcher
		def onNewModel(model)
			begin
				model.definitions.remove_observer(DO)
				model.definitions.add_observer(DO)
			rescue
				raise
			end
			ents = model.entities
			begin
				ents.remove_observer(EO)
				ents.add_observer(EO)
			rescue
				raise
			end
			model.definitions.each{|definition|
				next if ! definition.valid? || definition.image?
				begin
					definition.entities.remove_observer(EO)
					definition.entities.add_observer(EO)
				rescue
					raise
				end
			}
			begin
				Sketchup.remove_observer(AO)
				Sketchup.add_observer(AO)
			rescue
				raise
			end
			layers = model.layers
			begin
				layers.remove_observer(LO)
				layers.add_observer(LO)
			rescue
				raise
			end
		end
		def onOpenModel(model)
			begin
				model.definitions.remove_observer(DO)
				model.definitions.add_observer(DO)
			rescue
				raise
			end
			ents = model.entities
			begin
				ents.remove_observer(EO)
				ents.add_observer(EO)
			rescue
				raise
			end
			model.definitions.each{|definition|
				next if ! definition.valid? || definition.image?
				begin
					definition.entities.remove_observer(EO)
					definition.entities.add_observer(EO)
				rescue
					raise
				end
			}
			begin
				Sketchup.remove_observer(AO)
				Sketchup.add_observer(AO)
			rescue
				raise
			end
			layers = model.layers
			begin
				layers.remove_observer(LO)
				layers.add_observer(LO)
			rescue
				raise
			end
		end
		def onActivateModel(model) ### MAC
			begin
				model.definitions.remove_observer(DO)
				model.definitions.add_observer(DO)
			rescue
				raise
			end
			ents = model.entities
			begin
				ents.remove_observer(EO)
				ents.add_observer(EO)
			rescue
				raise
			end
			model.definitions.each{|definition|
				next if ! definition.valid? || definition.image?
				begin
					definition.entities.remove_observer(EO)
					definition.entities.add_observer(EO)
				rescue
					raise
				end
			}
			begin
				Sketchup.remove_observer(AO)
				Sketchup.add_observer(AO)
			rescue
				raise
			end
			layers = model.layers
			begin
				layers.remove_observer(LO)
				layers.add_observer(LO)
			rescue
				raise
			end
		end
	end
	### add App observer to SketchUp initially
	AO = AppObserver.new()
	begin
		Sketchup.remove_observer(AO)
		Sketchup.add_observer(AO)
	rescue
		raise
	end
	###
 end#module
end#module
